## elektra 0.8.7

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)

project (Elektra)

#additional modules for loading libraries
set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")


#needed by ifs below
include (cmake/ElektraCache.cmake)
include (cmake/ElektraCompiling.cmake)
if (ENABLE_COVERAGE)
	include (cmake/ElektraCoverage.cmake)
endif (ENABLE_COVERAGE)

if (ENABLE_TESTING)
	enable_testing ()
	include (Dart)
endif (ENABLE_TESTING)

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
	if (NOT FORCE_IN_SOURCE_BUILD)
		message(FATAL_ERROR
				"In-source builds are not permitted.\n"
				"Make a separate folder for building:\n"
				"    mkdir build && cd build && cmake ..\n"
				"Before that, remove the files already created:\n"
				"    rm -rf CMakeCache.txt CMakeFiles\n"
				"If you really know what you are doing\n"
				"(will overwrite original files!) use:\n"
				"    cmake -DFORCE_IN_SOURCE_BUILD=ON\n"
			)
	endif (NOT FORCE_IN_SOURCE_BUILD)
endif(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)

if (NOT CMAKE_BUILD_TYPE)
	SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif (NOT CMAKE_BUILD_TYPE)


#some basic and important variables
set (DOMAIN libelektra.org) #needed by doxygen
set (REVERSE_DOMAIN org.libelektra)

set (KDB_VERSION_MAJOR 0)
set (KDB_VERSION_MINOR 8)
set (KDB_VERSION_MICRO 7)

set (KDB_VERSION "${KDB_VERSION_MAJOR}.${KDB_VERSION_MINOR}.${KDB_VERSION_MICRO}")

set (SO_VERSION 4)
#set (SO_VERSION_TOOLS 3)

#needs version above
include (cmake/ElektraPackaging.cmake)

#now add all directories
add_subdirectory (cmake)
add_subdirectory (src)

if (BUILD_DOCUMENTATION)
	add_subdirectory (doc)
endif (BUILD_DOCUMENTATION)

if (BUILD_TESTING)
	if (BUILD_FULL OR BUILD_STATIC)
		add_subdirectory (tests)
	else (BUILD_FULL OR BUILD_STATIC)
		message(WARNING "Requested to build testing, but is impossible because neither full or static build active")
	endif (BUILD_FULL OR BUILD_STATIC)
endif (BUILD_TESTING)

if (BUILD_FULL OR BUILD_STATIC)
	if (BUILD_EXAMPLES)
		add_subdirectory (examples)
	else (BUILD_EXAMPLES)
		message(WARNING "Requested to build examples, but is impossible because neither full or static build active")
	endif (BUILD_EXAMPLES)
endif (BUILD_FULL OR BUILD_STATIC)

if (BUILD_FULL OR BUILD_STATIC)
	add_subdirectory (benchmarks EXCLUDE_FROM_ALL)
endif (BUILD_FULL OR BUILD_STATIC)

ADD_CUSTOM_TARGET(uninstall
	"${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_SOURCE_DIR}/cmake/ElektraUninstall.cmake")

configure_file(
	"${CMAKE_CURRENT_SOURCE_DIR}/scripts/make-source-package.in"
	"${CMAKE_CURRENT_BINARY_DIR}/scripts/make-source-package")

ADD_CUSTOM_TARGET(source-package
		COMMAND "${CMAKE_CURRENT_BINARY_DIR}/scripts/make-source-package"
		COMMENT "Make a elektra source package by using git"
		VERBATIM
		WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
		)

=== benchmarks/CMakeLists.txt ===
include (LibAddMacros)

add_headers (HDR_FILES)

macro (do_benchmark source)
	include_directories ("${CMAKE_CURRENT_SOURCE_DIR}")
	set (SOURCES ${HDR_FILES} benchmarks.c benchmarks.h ${source}.c)
	add_executable (${source} ${SOURCES})

	if (BUILD_FULL)
		target_link_libraries (${source} elektra-full)
	else (BUILD_FULL)
		target_link_libraries (${source} elektra-static)
	endif (BUILD_FULL)

	set_target_properties (${source} PROPERTIES
			COMPILE_DEFINITIONS HAVE_KDBCONFIG_H)

	get_target_property (command ${source} LOCATION)

	add_custom_target (benchmark
		rm -f *.out
		COMMAND valgrind --tool=callgrind --callgrind-out-file=callgrind.out "${command}" > output.out
		# COMMAND strace -o strace.out "${command}"
		WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
		)
endmacro (do_benchmark)

do_benchmark (large)

=== cmake/CMakeLists.txt ===
#ElektraPackaging needs to be included first (sets PACKAGE_ variables)

#cmake settings for use by find_package
configure_file (
		"${CMAKE_CURRENT_SOURCE_DIR}/FindElektra.cmake.in"
		"${CMAKE_CURRENT_BINARY_DIR}/FindElektra.cmake"
		@ONLY
	)

install ( FILES
		"${CMAKE_CURRENT_BINARY_DIR}/FindElektra.cmake"
		DESTINATION ${TARGET_CMAKE_FOLDER}
	)

#pkg-config files
configure_file (
		"${CMAKE_CURRENT_SOURCE_DIR}/elektra.pc.in"
		"${CMAKE_CURRENT_BINARY_DIR}/elektra.pc"
		@ONLY
	)

install ( FILES
		"${CMAKE_CURRENT_BINARY_DIR}/elektra.pc"
		DESTINATION lib${LIB_SUFFIX}/${TARGET_PKGCONFIG_FOLDER}
	)

=== doc/CMakeLists.txt ===
find_package(Doxygen)

# do_doc
#
#builds and install documentation
#
#target  is man, html or latex
#folder  is the folder where it will be built
#file    is the file name to set a depencency to
#install is where it should be installed
#
macro (do_doc target folder file install)
	add_custom_command (
		OUTPUT ${folder}/${file}
		COMMAND ${DOXYGEN_EXECUTABLE}
		ARGS ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
		DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
	)

	#get_filename_component (name ${target} NAME_WE)

	add_custom_target (${target} ALL
		DEPENDS ${folder}/${file}
	)

	if (INSTALL_DOCUMENTATION)
		install (
			DIRECTORY ${folder}
			DESTINATION ${install}
		)
	endif (INSTALL_DOCUMENTATION)
endmacro (do_doc)

if (DOXYGEN_FOUND)
	set (OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

	if (BUILD_PDF)
		find_package(LATEX)
		if (LATEX_COMPILER)
			set (WITH_LATEX YES)
		else (LATEX_COMPILER)
			set (WITH_LATEX NO)
			message (WARNING "Latex not found, PDF Manual can't be created.")
		endif (LATEX_COMPILER)
	else (BUILD_PDF)
		set (WITH_LATEX NO)
	endif (BUILD_PDF)

	if (DOXYGEN_DOT_FOUND)
		set (WITH_DOT YES)
	else (DOXYGEN_DOT_FOUND)
		set (WITH_DOT NO)
	endif (DOXYGEN_DOT_FOUND)

	find_package(Perl)

	configure_file (
		"${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile"
		"${CMAKE_CURRENT_BINARY_DIR}/Doxyfile"
		@ONLY
	)

	do_doc(html ${OUTPUT_DIRECTORY}/html/ index.html
		${TARGET_DOCUMENTATION_HTML_FOLDER})
	do_doc(man ${OUTPUT_DIRECTORY}/man/man3elektra/ kdb.3elektra
		"${TARGET_DOCUMENTATION_MAN_FOLDER};PATTERN;_*;EXCLUDE")

	if (WITH_LATEX)
		do_doc(latex ${OUTPUT_DIRECTORY}/latex/ refman.tex
			${TARGET_DOCUMENTATION_LATEX_FOLDER})

		add_custom_command (
			OUTPUT ${OUTPUT_DIRECTORY}/latex/refman.pdf
			COMMAND ${PDFLATEX_COMPILER} ARGS ${OUTPUT_DIRECTORY}/latex/refman.tex
			COMMAND ${PDFLATEX_COMPILER} ARGS ${OUTPUT_DIRECTORY}/latex/refman.tex
			COMMAND ${PDFLATEX_COMPILER} ARGS ${OUTPUT_DIRECTORY}/latex/refman.tex
			DEPENDS ${OUTPUT_DIRECTORY}/latex/refman.tex
			WORKING_DIRECTORY ${OUTPUT_DIRECTORY}/latex/
		)

		add_custom_target (pdf ALL
			DEPENDS ${OUTPUT_DIRECTORY}/latex/refman.pdf
		)
	endif (WITH_LATEX)
else (DOXYGEN_FOUND)
	message (WARNING "Doxygen not found, Reference Manual can't be created even though requested with BUILD_DOCUMENTATION.")
endif (DOXYGEN_FOUND)

=== examples/CMakeLists.txt ===
#project (examples)

#find_package (Elektra)

#if (ELEKTRA_FOUND)
#	include (${Elektra_USE_FILE})
#	add_executable (hello hello.c)
#	target_link_libraries (hello elektra)
#endif (ELEKTRA_FOUND)


include (LibAddMacros)

#don't call add_headers in a loop
add_headers (HDR_FILES)

macro (do_example source)
	include_directories ("${CMAKE_CURRENT_SOURCE_DIR}")
	set (SOURCES ${HDR_FILES} ${source}.c)
	add_executable (${source} ${SOURCES})

	if (BUILD_FULL)
		target_link_libraries (${source} elektra-full)
	else (BUILD_FULL)
		target_link_libraries (${source} elektra-static)
	endif (BUILD_FULL)

	set_target_properties (${source} PROPERTIES
			COMPILE_DEFINITIONS HAVE_KDBCONFIG_H)
endmacro (do_example)

file (GLOB TESTS *.c)
foreach (file ${TESTS})
	get_filename_component (name ${file} NAME_WE)
	do_example (${name})
endforeach (file ${TESTS})

=== src/CMakeLists.txt ===
add_subdirectory (include)

add_subdirectory (liberror)

add_subdirectory (libloader)

add_subdirectory (plugins)

add_subdirectory (libelektra)

add_subdirectory (bindings)

add_subdirectory (libtools)

add_subdirectory (tools)

=== tests/CMakeLists.txt ===
## Elektra Test Suite
#
# This file is responsible for generating all tests
# regarding elektra's core.
#
# Backends and Bindings specific tests might be in
# their folders.
#
# To run all tests, simply type:
#  make test
#
# To run specific tests, type:
#  ctest -R name
#
# To run tests with valgrind, type:
#  ctest -T memcheck
#
# To run verbose (to see output and commands), type:
#  ctest -V
#
# For example, to run keyset test with valgrind and verbose, type:
#  ctest -V -T memcheck -R ks
#
##

include (LibAddMacros)

#don't call add_headers in a loop
add_headers (HDR_FILES)

macro (do_test source)
	include_directories ("${CMAKE_CURRENT_SOURCE_DIR}")
	set (SOURCES ${HDR_FILES} ${source}.c tests.c)
	add_executable (${source} ${SOURCES})

	if (INSTALL_TESTING)
		install (TARGETS ${source}
			DESTINATION ${TARGET_TOOL_EXEC_FOLDER})
	endif (INSTALL_TESTING)

	if (BUILD_FULL)
		target_link_libraries (${source} elektra-full)
	else (BUILD_FULL)
		target_link_libraries (${source} elektra-static)
	endif (BUILD_FULL)

	set_target_properties (${source} PROPERTIES
			COMPILE_DEFINITIONS HAVE_KDBCONFIG_H)
	set_target_properties (${source} PROPERTIES LINKER_LANGUAGE CXX)
	add_test (${source}
			"${PROJECT_BINARY_DIR}/tests/${source}"
			"${PROJECT_BINARY_DIR}/tests"
			)
endmacro (do_test)

file (GLOB TESTS test_*.c)
foreach (file ${TESTS})
	get_filename_component (name ${file} NAME_WE)
	do_test (${name})
endforeach (file ${TESTS})

add_subdirectory (shell)

include_directories ("${PROJECT_SOURCE_DIR}/tests")

=== src/bindings/CMakeLists.txt ===
add_subdirectory (cpp)

if (BUILD_SWIG)
	find_package(SWIG 2 REQUIRED)
endif (BUILD_SWIG)

if (BUILD_SWIG_LUA)
	set (TARGET_LUA_CMOD_FOLDER "lib${LIB_SUFFIX}/lua/5.2"
		CACHE PATH
		"Directory to install Lua binary modules (configure lua via LUA_CPATH)"
	)
endif (BUILD_SWIG_LUA)

if (SWIG_FOUND)
	add_subdirectory (swig)
endif (SWIG_FOUND)

=== src/include/CMakeLists.txt ===
include(CheckIncludeFile)
include(CheckSymbolExists)
include(CheckTypeSize)

check_symbol_exists(clearenv     "stdlib.h"         HAVE_CLEARENV)
check_symbol_exists(setenv       "stdlib.h"         HAVE_SETENV)

check_include_file(ctype.h      HAVE_CTYPE_H)
check_include_file(errno.h      HAVE_ERRNO_H)
check_include_file(locale.h     HAVE_LOCALE_H)
check_include_file(stdio.h      HAVE_STDIO_H)
check_include_file(stdlib.h     HAVE_STDLIB_H)
check_include_file(string.h     HAVE_STRING_H)
check_include_file(time.h       HAVE_TIME_H)
check_include_file(unistd.h     HAVE_UNISTD_H)

check_type_size(int             SIZEOF_INT)
check_type_size(long            SIZEOF_LONG)
check_type_size("long long"     SIZEOF_LONG_LONG)
check_type_size("long double"   SIZEOF_LONG_DOUBLE)

set (BUILTIN_EXEC_FOLDER
	"${CMAKE_INSTALL_PREFIX}/${TARGET_TOOL_EXEC_FOLDER}")
set (BUILTIN_DATA_FOLDER
	"${CMAKE_INSTALL_PREFIX}/${TARGET_TEST_DATA_FOLDER}")
set (ELEKTRA_DEPRECATED "__attribute__ ((deprecated))")
set (ELEKTRA_UNUSED "__attribute__ ((unused))")

configure_file (
	"${CMAKE_CURRENT_SOURCE_DIR}/kdb.h.in"
	"${CMAKE_CURRENT_BINARY_DIR}/kdb.h"
	)

configure_file (
	"${CMAKE_CURRENT_SOURCE_DIR}/kdbconfig.h.in"
	"${CMAKE_CURRENT_BINARY_DIR}/kdbconfig.h"
	)

configure_file (
	"${CMAKE_CURRENT_SOURCE_DIR}/kdbversion.h.in"
	"${CMAKE_CURRENT_BINARY_DIR}/kdbversion.h"
	)

install (FILES
	"${CMAKE_CURRENT_BINARY_DIR}/kdbconfig.h"
	kdbextension.h
	kdbtypes.h
	"${CMAKE_CURRENT_BINARY_DIR}/kdb.h"
	kdbinternal.h
	kdbmodule.h
	kdbos.h
	kdbplugin.h
	kdbprivate.h
	kdbtools.h
	"${CMAKE_CURRENT_BINARY_DIR}/kdbversion.h"
	DESTINATION include/${TARGET_INCLUDE_FOLDER})

=== src/libelektra/CMakeLists.txt ===
# For static inclusion of libraries we need a list
# of symbols to make the static runtime linker work.
#
# For that there is the program exportsymbols which
# generates the sourcefiles exported_symbols.h
# and exported_symbols.c containing an array of
# all symbols.
#
# The program needs a list of all backends as
# argument.
#
# Symbols of libelektratools will be treaded specially.
add_executable (exportsymbols exportsymbols.c)

if (CMAKE_CROSSCOMPILING)
	find_program (EXE_SYM_LOC exportsymbols)
else (CMAKE_CROSSCOMPILING)
	get_target_property (EXE_SYM_LOC exportsymbols LOCATION)
endif (CMAKE_CROSSCOMPILING)

add_custom_command (
		OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/exported_symbols.h
		DEPENDS exportsymbols
		COMMAND ${EXE_SYM_LOC}
		ARGS ${PLUGINS}
		)

add_custom_command (
		OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/exported_symbols.c
		DEPENDS exportsymbols
		COMMAND ${EXE_SYM_LOC}
		ARGS ${PLUGINS}
		)


# Include the shared header files of the elektra project
include(LibAddMacros)
add_headers(HDR_FILES)
# not always needed.. only with cppplugins
add_cppheaders(HDR_FILES)

#include the current binary directory to get exported_symbols.h
include_directories("${CMAKE_CURRENT_BINARY_DIR}")

#now add all source files of this folder
file (GLOB SRC_FILES *.c)

#remove those we don't want..
file (GLOB RM_FILES exportsymbols.c kdbmainpage.c)
list (REMOVE_ITEM SRC_FILES ${RM_FILES})

#now add all source files of other folders
get_property (elektra_SRCS GLOBAL PROPERTY elektra_SRCS)
list (APPEND SRC_FILES ${elektra_SRCS})

set (SOURCES ${SRC_FILES} ${HDR_FILES})
list (APPEND SOURCES "${CMAKE_CURRENT_BINARY_DIR}/exported_symbols.h")


if (BUILD_SHARED)
	get_property (elektra-shared_SRCS GLOBAL PROPERTY elektra-shared_SRCS)
	add_library (elektra SHARED ${SOURCES} ${elektra-shared_SRCS})

	get_property (elektra-shared_LIBRARIES GLOBAL PROPERTY elektra-shared_LIBRARIES)
	target_link_libraries (elektra ${elektra-shared_LIBRARIES})

	get_property (elektra-shared_INCLUDES GLOBAL PROPERTY elektra-shared_INCLUDES)
	include_directories (${elektra-shared_INCLUDES})

	set_target_properties (elektra PROPERTIES
			COMPILE_DEFINITIONS HAVE_KDBCONFIG_H)
	set_target_properties (elektra PROPERTIES
			VERSION ${KDB_VERSION} SOVERSION ${SO_VERSION})
	set_target_properties (elektra PROPERTIES CLEAN_DIRECT_OUTPUT 1)

	#search only in the prefix the user decided to install elektra
	#(e.g. /usr/local/)
	set (ELEKTRA_RPATH "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}/${TARGET_PLUGIN_FOLDER}")

	#RPATH settings, see http://www.itk.org/Wiki/CMake_RPATH_handling
	#those settings are needed to find the plugins at runtime even without ld.so.conf
	set_target_properties ( elektra PROPERTIES INSTALL_RPATH "${ELEKTRA_RPATH}")

	install (TARGETS elektra DESTINATION lib${LIB_SUFFIX})
endif (BUILD_SHARED)

if (BUILD_FULL OR BUILD_STATIC)
	#for the next two builds, append some more sources
	get_property (elektra-full_SRCS GLOBAL PROPERTY elektra-full_SRCS)
	list (APPEND SOURCES ${elektra-full_SRCS}
		${BINARY_INCLUDE_DIR}/kdberrors.h)
	list (APPEND SOURCES "${CMAKE_CURRENT_BINARY_DIR}/exported_symbols.c")

	#and get all libraries to link against
	get_property (elektra-full_LIBRARIES GLOBAL PROPERTY elektra-full_LIBRARIES)

	# include the directories of all libraries for the static or
	# full-shared build
	get_property (elektra-full_INCLUDES GLOBAL PROPERTY elektra-full_INCLUDES)

	include_directories (${elektra-full_INCLUDES})
endif (BUILD_FULL OR BUILD_STATIC)


if (BUILD_FULL)
	add_library (elektra-full SHARED ${SOURCES})

	target_link_libraries (elektra-full ${elektra-full_LIBRARIES})

	set_target_properties (elektra-full PROPERTIES
			COMPILE_DEFINITIONS "HAVE_KDBCONFIG_H;ELEKTRA_STATIC")
	set_target_properties (elektra-full PROPERTIES
			VERSION ${KDB_VERSION} SOVERSION ${SO_VERSION})
	set_target_properties (elektra-full PROPERTIES CLEAN_DIRECT_OUTPUT 1)
	set_target_properties (elektra-full PROPERTIES LINKER_LANGUAGE CXX)

	install (TARGETS elektra-full DESTINATION lib${LIB_SUFFIX})
endif (BUILD_FULL)


if (BUILD_STATIC)
	add_library (elektra-static STATIC ${SOURCES})

	target_link_libraries (elektra-static ${elektra-full_LIBRARIES})

	set_target_properties (elektra-static PROPERTIES
			COMPILE_DEFINITIONS "HAVE_KDBCONFIG_H;ELEKTRA_STATIC")
	set_target_properties (elektra-static PROPERTIES
			VERSION ${KDB_VERSION} SOVERSION ${SO_VERSION})
	set_target_properties (elektra-static PROPERTIES CLEAN_DIRECT_OUTPUT 1)
	set_target_properties (elektra-static PROPERTIES LINKER_LANGUAGE CXX)

	install (TARGETS elektra-static DESTINATION lib${LIB_SUFFIX})
endif (BUILD_STATIC)

#if you want the same name for those 3 libraries, here is how to do it:
#http://www.itk.org/Wiki/CMake_FAQ#How_do_I_make_my_shared_and_static_libraries_have_the_same_root_name.2C_but_different_suffixes.3F

=== src/liberror/CMakeLists.txt ===
add_executable(exporterrors exporterrors.cpp parser.hpp parser.cpp)

set_source_files_properties(exporterrors OBJECT_DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/specification)

=== src/libloader/CMakeLists.txt ===
include (LibAddMacros)

add_sources (elektra-full "static.c")

if (BUILD_SHARED)
	find_package (DL REQUIRED)
	if (DL_FOUND)
		add_sources (elektra-shared "dl.c")
		add_includes (elektra-shared ${DL_INCLUDE_DIRS})
		add_libraries (elektra-shared ${DL_LIBRARIES})
	else (DL_FOUND)
		message (ERROR "dl not found and no other module mechanism currently defined, see src/libloader")
	endif (DL_FOUND)
endif (BUILD_SHARED)

=== debian/changelog ===
elektra (0.8.7-4) unstable; urgency=medium

  * Upload to unstable.
  * Do not compress files installed as examples.

 -- Pino Toscano <pino@debian.org>  Tue, 19 Aug 2014 20:19:38 +0200

elektra (0.8.7-3) experimental; urgency=medium

  * Adapt the install path of FindElektra.cmake to work also with cmake 3.
  * Bump the cmake build dependency to >= 2.8, as indicated by the upstream
    build system.
  * Tighten libelektra4 dependency in all the binary packages.
  * Install the C examples, the ones of the C++ bindings, and the external
    project ones in libelektra-dev.
  * Rename the lua and python3 autopkgtest as examples-lua and examples-python3
    since that's what they test.
  * Add a new examples-c-cpp autopkgtest to build and run (almost) all the
    C examples, the C++ examples, and the external project ones.
  * Install the bash completion for the kdb tool:
    - add the bash-completion build dependency
    - use the bash_completion dh addon
    - add a elektra-bin.bash-completion file
  * Update copyright.
  * Backport upstream commits e8d6404d0331fed369f0b133bbfe871f52c03488 and
    395c1ce36d530ea9edd5dcc269b74bf1901b8957 to fix/improve the handling of
    mode_t; patches upstream_cmake-check-and-store-the-size-of-mode_t.patch
    and upstream_Make-KEY_MODE-work-when-mode_t-is-not-the-same-as-in.patch.

 -- Pino Toscano <pino@debian.org>  Mon, 18 Aug 2014 23:18:11 +0200

elektra (0.8.7-2) experimental; urgency=medium

  * rules: fix typo in variable name.
  * Backport upstream commit b4ff5fa57ab0d7f63f0f71c0db621bdf8ec53d8f to
    properly pass the KEY_END marker in all the C++ Key::Key calls; patch
    upstream_Add-the-KEY_END-marker-on-key-creation-where-missing.patch.
  * Backport upstream commit 2bb9542d0c45622a8254156fbf2b876eaf21858f to
    switch from tmpnam to mkstemp in tests; patch
    upstream_tests-switch-from-tmpnam-to-mkstemp.patch.
  * Provide a temporary directory as HOME and TMPDIR for the tests.
  * Switch from PATH_MAX to KDB_MAX_PATH_LENGTH in kdb; patch path_max.diff.
  * Workaround in the bindings the ambiguous varargs constructors of the C++
    KeySet implementation (upstream bug #42); patch ambiguous_keyset_ctor.diff.

 -- Pino Toscano <pino@debian.org>  Wed, 13 Aug 2014 06:21:42 +0200

elektra (0.8.7-1) experimental; urgency=medium

  * New upstream release.
  * Update the patches:
    - upstream_swig-lua-python-fix-installation-directory.patch: drop,
      backported
    - upstream_install_lua.diff: drop, backported
    - upstream_Add-TARGET_LUA_CMOD_FOLDER-cmake-variable.patch: drop,
      backported
    - upstream_cmake-simplify-RPATH-setting.patch: drop, backported
    - spelling_fixes.diff: drop, fixed upstream
  * Update symbols file.
  * Build with an external gtest:
   - add the libgtest-dev build dependency
   - pass -DGTEST_ROOT to cmake
  * Update install files.
  * Rename -DBUILD_SWIG_PYTHON cmake variable to -DBUILD_SWIG_PYTHON3,
    as changed upstream.
  * Switch to swig 3.0, as it works better for the Python 3 bindings:
    - switch the swig build dependency to swig3.0
    - pass -DSWIG_EXECUTABLE to cmake
    - drop patch python_tests_skip_crash.diff, obsolete now
  * Fix path to the python3 examples.
  * Manually install the test data for the xmltool plugin, so its
    testmod_xmltool test pass.
  * Extend private_elektratools.diff to also set RPATH for the elektratools
    tests.
  * When not building elektra-doc, disable the build of the documentation:
    - in rules, put the common arguments for cmake in an own variable, hacking
      override_dh_auto_configure to pass -DBUILD_DOCUMENTATION=OFF in that case
    - move the docbook-xml, docbook-xsl, doxygen, graphviz, and xsltproc build
      dependencies to Build-Depends-Indep
  * Remove the docbook-xml, docbook-xsl, and xsltproc build dependencies,
    as they unused now.

 -- Pino Toscano <pino@debian.org>  Wed, 06 Aug 2014 23:25:31 +0200

elektra (0.8.6-1) experimental; urgency=medium

  * New upstream release.
  * Upstream switched from autotools to cmake, so:
    - drop the dh-autoreconf and libltdl-dev build dependencies
    - add the cmake build dependency
    - stop using the autoreconf dh addon
    - force the use of cmake as build system
    - drop patch docdata_install.diff, no more needed now
    - turn the configure arguments for plugin and apidox directories into
      cmake options
  * Drop libelektra-cpp library, since the C++ headers provide inline
    implementations, and move them to libelektra-dev.
  * Move libelektratools in a private location, since upstream does not
    consider it a public library yet, setting RPATH in kdb to load it; patch
    private_elektratools.diff:
    - disable libelektratoolsN and libelektratools-dev packages for now
  * Rename packages according to the new SONAMEs:
    - libelektra3 -> libelektra4
  * Update install files.
  * Update symbols files.
  * Update doc-base file.
  * Add a new elektra-tests package with the tools and data for the installed
    test suite.
  * Build all the tools and plugins:
    - add the libboost-dev, libdbus-1-dev, and libyajl-dev build dependencies
    - add the libelektra4-dbus, libelektra4-xmltool, and libelektra4-yajl
      packages for the respective plugins, as they bring additional
      dependencies
  * Backport upstream commit e609279f6ca78c39f8dd17f87a215d80c8464dde to set
    RPATH only for the plugin directory in the installation prefix; patch
    upstream_cmake-simplify-RPATH-setting.patch.
  * Start enabling the bindings:
    - pass -DBUILD_SWIG=ON to cmake
    - add the swig build dependency
  * Enable the Lua bindings:
    - add the lua-elektra package
    - add the dh-lua build dependency
    - use the lua dh addon
    - backport upstream commits 27a24cfe85057825afb6f9fca5d4b2dc70d8cf9b and
      8e242a850e051c98a31aaf93bad09778e81a20f8 to install the bindings in the
      correct location; patches upstream_install_lua.diff and


=== debian/control ===
Source: elektra
Section: misc
Priority: optional
Maintainer: Pino Toscano <pino@debian.org>
Build-Depends: debhelper (>= 9),
 cmake (>= 2.8),
 pkg-config (>= 0.9.0),
 libboost-dev,
 libdbus-1-dev,
 libyajl-dev,
 libxml2-dev,
 swig3.0,
 dh-lua,
 python3-dev,
 libgtest-dev,
 bash-completion,
Build-Depends-Indep:
 doxygen,
 graphviz,
Standards-Version: 3.9.5
Homepage: http://www.libelektra.org/
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=users/pino/elektra.git
Vcs-Git: git://anonscm.debian.org/users/pino/elektra.git
XS-Testsuite: autopkgtest

Package: libelektra4
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
 ${misc:Depends}
Suggests: elektra-doc
Description: elektra configuration store, main library
 Elektra provides a universal and secure framework to store configuration
 parameters in a hierarchical key-value pair mechanism, instead of each
 program using its own text configuration files. This allows any program
 to read and save its configuration with a consistent API, and allows
 them to be aware of other applications' configurations, permitting
 easy application integration. While architecturally similar to other OS
 registries, Elektra does not have most of the problems found in those
 implementations.
 .
 This package contains the main elektra library, and most of the core plugins.

Package: libelektra-dev
Section: libdevel
Architecture: any
Depends: libelektra4 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: elektra configuration store, main library [development]
 Elektra provides a universal and secure framework to store configuration
 parameters in a hierarchical key-value pair mechanism, instead of each
 program using its own text configuration files. This allows any program
 to read and save its configuration with a consistent API, and allows
 them to be aware of other applications' configurations, permitting
 easy application integration. While architecturally similar to other OS
 registries, Elektra does not have most of the problems found in those
 implementations.
 .
 This package contains the development files for the main elektra library.

#Package: libelektratools4
#Section: libs
#Architecture: any
#Multi-Arch: same
#Pre-Depends: ${misc:Pre-Depends}
#Depends: libelektra4 (= ${binary:Version}),
# ${shlibs:Depends},
# ${misc:Depends}
#Description: elektra configuration store, elektratools library
# Elektra provides a universal and secure framework to store configuration
# parameters in a hierarchical key-value pair mechanism, instead of each
# program using its own text configuration files. This allows any program
# to read and save its configuration with a consistent API, and allows
# them to be aware of other applications' configurations, permitting
# easy application integration. While architecturally similar to other OS
# registries, Elektra does not have most of the problems found in those
# implementations.
# .
# This package contains the elektratools library.
#
#Package: libelektratools-dev
#Section: libdevel
#Architecture: any
#Depends: libelektratools4 (= ${binary:Version}),
# libelektra-dev (= ${binary:Version}),
# ${shlibs:Depends},
# ${misc:Depends}
#Description: elektra configuration store, elektratools library [development]
# Elektra provides a universal and secure framework to store configuration
# parameters in a hierarchical key-value pair mechanism, instead of each
# program using its own text configuration files. This allows any program
# to read and save its configuration with a consistent API, and allows
# them to be aware of other applications' configurations, permitting
# easy application integration. While architecturally similar to other OS
# registries, Elektra does not have most of the problems found in those
# implementations.
# .
# This package contains the development files for the elektratools library.

Package: libelektra4-dbus
Section: libs
Architecture: any
Depends: libelektra4 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: elektra configuration store, dbus plugin
 Elektra provides a universal and secure framework to store configuration
 parameters in a hierarchical key-value pair mechanism, instead of each
 program using its own text configuration files. This allows any program
 to read and save its configuration with a consistent API, and allows
 them to be aware of other applications' configurations, permitting
 easy application integration. While architecturally similar to other OS
 registries, Elektra does not have most of the problems found in those
 implementations.
 .
 This package contains the 'dbus' plugin.

Package: libelektra4-xmltool
Section: libs
Architecture: any
Depends: libelektra4 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: elektra configuration store, xmltool plugin
 Elektra provides a universal and secure framework to store configuration
 parameters in a hierarchical key-value pair mechanism, instead of each
 program using its own text configuration files. This allows any program
 to read and save its configuration with a consistent API, and allows
 them to be aware of other applications' configurations, permitting
 easy application integration. While architecturally similar to other OS
 registries, Elektra does not have most of the problems found in those
 implementations.
 .
 This package contains the 'xmltool' plugin.

Package: libelektra4-yajl
Section: libs
Architecture: any
Depends: libelektra4 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: elektra configuration store, yajl plugin
 Elektra provides a universal and secure framework to store configuration
 parameters in a hierarchical key-value pair mechanism, instead of each
 program using its own text configuration files. This allows any program
 to read and save its configuration with a consistent API, and allows
 them to be aware of other applications' configurations, permitting
 easy application integration. While architecturally similar to other OS
 registries, Elektra does not have most of the problems found in those
 implementations.
 .
 This package contains the 'yajl' plugin.

Package: lua-elektra
Section: interpreters
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libelektra4 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: elektra configuration store, Lua bindings
 Elektra provides a universal and secure framework to store configuration
 parameters in a hierarchical key-value pair mechanism, instead of each
 program using its own text configuration files. This allows any program
 to read and save its configuration with a consistent API, and allows
 them to be aware of other applications' configurations, permitting
 easy application integration. While architecturally similar to other OS
 registries, Elektra does not have most of the problems found in those
 implementations.
 .
 This package contains the Lua bindings.

Package: python3-elektra
Section: python
Architecture: any
Depends: libelektra4 (= ${binary:Version}),
 ${shlibs:Depends},
 ${python3:Depends},
 ${misc:Depends}
Description: elektra configuration store, Python 3 bindings
 Elektra provides a universal and secure framework to store configuration
 parameters in a hierarchical key-value pair mechanism, instead of each
 program using its own text configuration files. This allows any program
 to read and save its configuration with a consistent API, and allows
 them to be aware of other applications' configurations, permitting
 easy application integration. While architecturally similar to other OS
 registries, Elektra does not have most of the problems found in those
 implementations.
 .
 This package contains the Python 3 bindings.

Package: elektra-bin
Architecture: any
Multi-Arch: foreign
Depends: libelektra4 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Conflicts: kernel-patch-kdb
Description: elektra configuration store, binaries
 Elektra provides a universal and secure framework to store configuration
 parameters in a hierarchical key-value pair mechanism, instead of each
 program using its own text configuration files. This allows any program
 to read and save its configuration with a consistent API, and allows
 them to be aware of other applications' configurations, permitting
 easy application integration. While architecturally similar to other OS
 registries, Elektra does not have most of the problems found in those
 implementations.
 .
 This package contains command line utilities for Elektra.

Package: elektra-tests
Priority: extra
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: libelektra4 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: elektra configuration store, tests
 Elektra provides a universal and secure framework to store configuration
 parameters in a hierarchical key-value pair mechanism, instead of each
 program using its own text configuration files. This allows any program
 to read and save its configuration with a consistent API, and allows
 them to be aware of other applications' configurations, permitting
 easy application integration. While architecturally similar to other OS
 registries, Elektra does not have most of the problems found in those
 implementations.
 .
 This package contains the Elektra test suite.

Package: elektra-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: elektra configuration store, API documentation
 Elektra provides a universal and secure framework to store configuration
 parameters in a hierarchical key-value pair mechanism, instead of each
 program using its own text configuration files. This allows any program
 to read and save its configuration with a consistent API, and allows
 them to be aware of other applications' configurations, permitting
 easy application integration. While architecturally similar to other OS
 registries, Elektra does not have most of the problems found in those
 implementations.
 .
 This package contains the API documentation for the Elektra libraries.

Package: elektra-dbg
Section: debug
Priority: extra
Architecture: any
Multi-Arch: same
Depends: libelektra4 (= ${binary:Version}),
 ${misc:Depends}
Description: elektra configuration store, debug symbols
 Elektra provides a universal and secure framework to store configuration
 parameters in a hierarchical key-value pair mechanism, instead of each
 program using its own text configuration files. This allows any program
 to read and save its configuration with a consistent API, and allows
 them to be aware of other applications' configurations, permitting
 easy application integration. While architecturally similar to other OS
 registries, Elektra does not have most of the problems found in those
 implementations.
 .
 This package contains the debug symbols for all the Elektra components.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

PY3VER = $(shell py3versions -d -v)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
CMAKE_ARGS = -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" \
  -DTARGET_PLUGIN_FOLDER="elektra4" \
  -DPLUGINS="ALL" \
  -DTOOLS="ALL" \
  -DBUILD_STATIC=OFF \
  -DBUILD_SWIG=ON -DSWIG_EXECUTABLE="/usr/bin/swig3.0" \
  -DBUILD_SWIG_LUA=ON \
  -DBUILD_SWIG_PYTHON3=ON -DPython_ADDITIONAL_VERSIONS="$(PY3VER)" \
  -DGTEST_ROOT="/usr/src/gtest" \
  -DTARGET_DOCUMENTATION_HTML_FOLDER="share/doc/elektra-doc/html"
CMAKE_ARGS_arch = -DBUILD_DOCUMENTATION=OFF
T = $(CURDIR)/teststmp

%:
	dh $@ --parallel --buildsystem=cmake --with lua,python3,bash_completion

override_dh_auto_configure:
ifneq (,$(filter %-doc,$(shell dh_listpackages)))
	dh_auto_configure --buildsystem=cmake -- $(CMAKE_ARGS)
else
	dh_auto_configure --buildsystem=cmake -- $(CMAKE_ARGS) $(CMAKE_ARGS_arch)
endif

override_dh_auto_test:
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	mkdir -p "$(T)"
	cd obj-* && env HOME="$(T)" TMPDIR="$(T)" ctest --output-on-failure -E 'testscr_.*'
	find "$(T)" | sort
	rm -rf "$(T)"
endif

override_dh_auto_install:
	dh_auto_install
	find $(CURDIR)/debian/tmp \( -name '*.map' -o -name '*.md5' \) -delete

override_dh_install:
	dh_install --list-missing

override_dh_compress:
	dh_compress -X.lua -Xexamples

override_dh_strip:
	dh_strip --dbg-package=elektra-dbg

override_dh_makeshlibs:
	dh_makeshlibs -Xusr/lib/$(DEB_HOST_MULTIARCH)/elektra4
